Index: trunk/Poubelle/archTOI.old/archfileset.h
===================================================================
--- trunk/Poubelle/archTOI.old/archfileset.h	(revision 534)
+++ trunk/Poubelle/archTOI.old/archfileset.h	(revision 534)
@@ -0,0 +1,65 @@
+// archfileset.h
+// Eric Aubourg         CEA/DAPNIA/SPP   septembre 1999
+
+#ifndef ARCHFILESET_H
+#define ARCHFILESET_H
+
+#include "archeopsfile.h"
+
+#include <set>
+#include <map>
+
+using namespace std;
+
+class TOILowLevProducer;
+
+class ArchFileSet {
+public:
+  ArchFileSet();
+  ArchFileSet(ArchFileSet const&);
+  ~ArchFileSet();
+  
+  void addFile(string);
+  void addDirectory(string);
+  void setSNumRange(long start, long end);
+  void setMJDRange(double start, double end);
+  void init(); // Opens the first file.
+  bool next();
+  
+  block_type_param*         lastParam();  
+  block_type_journal*       lastJournal();
+  block_type_reglage*       lastReglage();
+  block_type_dilution*      lastDilution();
+  block_type_gps*           lastGPS();
+  block_type_une_periode*   lastUnePeriode();
+  block_type_synchro_sol*   lastSynchroSol();
+  block_type_pointage_sol*  lastPointageSol();
+  block_type_bolo*          lastBolo();   
+  block_type_gyro*          lastGyro();
+  block_type_sst*           lastSST();
+  block_type_bolo_comprime* lastBoloComp();   
+  block_type_gyro_comprime* lastGyroComp();
+  block_type_sst_comprime*  lastSSTComp();
+  
+  void   registerProducer(TOILowLevProducer*, int blk_kind);
+  long   getSampleIndex();             // numero d''echantillon 
+  double getMJD();            
+
+protected:
+  set<string> filenames;
+  set<string> directories;
+  map<string, long> file1stSamp; // premier echantillon de chaque fichier
+  set<string>::iterator curFile;
+  ArcheopsFile* file;
+            
+  void scanFiles(); // Parcourt tous les fichiers, cherche le premier echantillon...
+  long nextSample(); // no test of trange
+  bool nextFile();
+  long sStart, sEnd;      // samplenum
+  double mjdStart, mjdEnd;    
+  long trigMask;
+  bool initDone;
+  bool endFound;
+};
+
+#endif
Index: trunk/Poubelle/archTOI.old/archparam.cc
===================================================================
--- trunk/Poubelle/archTOI.old/archparam.cc	(revision 533)
+++ trunk/Poubelle/archTOI.old/archparam.cc	(revision 534)
@@ -38,2 +38,25 @@
   cout << "***END" << endl;
 }
+
+double ArchParam::AcqParam::SN2MJD(double sample) {
+  return tBlock0 + sample*perEch/86400.;
+}
+
+
+double ArchParam::AcqParam::MJD2UTC(double mjd) {
+  return (mjd - utcOrigin)*24. ;
+}
+
+double ArchParam::AcqParam::UTC2MJD(double utc) {
+  return utc/24 + utcOrigin;
+}
+
+double ArchParam::AcqParam::SN2UTC(double sample) {
+  return MJD2UTC(SN2MJD(sample));
+}
+
+
+double ArchParam::AcqParam::MJD2SN(double mjd) {
+  return (mjd - tBlock0)/perEch*86400.;
+}
+
Index: trunk/Poubelle/archTOI.old/archparam.h
===================================================================
--- trunk/Poubelle/archTOI.old/archparam.h	(revision 533)
+++ trunk/Poubelle/archTOI.old/archparam.h	(revision 534)
@@ -11,4 +11,9 @@
     double utcOrigin;
     AcqParam(); 
+    double SN2MJD(double snum);
+    double SN2UTC(double snum);
+    double MJD2UTC(double mjd);
+    double UTC2MJD(double utc);
+    double MJD2SN(double mjd);
   };
   
Index: trunk/Poubelle/archTOI.old/archtoi.cc
===================================================================
--- trunk/Poubelle/archTOI.old/archtoi.cc	(revision 533)
+++ trunk/Poubelle/archTOI.old/archtoi.cc	(revision 534)
@@ -9,5 +9,6 @@
 
 #include "archeopsfile.h"
-#include "toisvr.h"
+#include "toiiter.h"
+#include "toimanager.h"
 #include "archtoi.h"
 #include "archparam.h"
@@ -39,5 +40,5 @@
 {
   init();
-  svr.readReq(str);
+  iter.readReq(str);
 }
 
@@ -47,5 +48,5 @@
   init();
   ifstream str(filename.c_str());
-  svr.readReq(str);
+  iter.readReq(str);
 }
 
@@ -59,22 +60,14 @@
   ostr = NULL;
   requestVersion = "";
-  svr.registerReqHandler(this);
-}
-
-
-bool ArchTOI::processTOIReq(string line, string toiname, TOIKind /*kind*/, int index, 
-                            bool interp, bool repet, bool flag, bool /*notrig*/)
+  iter.registerReqHandler(this);
+  
+  TOIManager::registerDefaultProducers();
+}
+
+
+bool ArchTOI::processTOIReq(TOI const& toi, string line)
 {
   headertoi.push_back(line);
-  if (index>=0) {
-    char idx[10]; 
-    sprintf(idx,"_%d",index);
-    toiname += idx;
-  }
-  if (flag) {
-    toinames.push_back("flg_"+toiname);
-  }
-  toinames.push_back(toiname);
-  toiflags.push_back(flg((flag?hasflag:0)+((!repet&&!interp)?useNA:0)));
+  tois.push_back(toi);
   return true;
 } 
@@ -130,11 +123,11 @@
   
   cout << "starting query" << endl;
-  TOIIter iter = svr.doQuery();
+  iter.init();
   (this->*openFile)(outfilename);
   (this->*outHeader)(iter);
   
   cout << "processing" << endl;
-  while (iter.Next()) {
-    int nn = iter.getSampleIndex() / iter.getUnderSampling(); // Only for tick mark...
+  while (iter.next()) {
+    int nn = iter.getSampleNum() / iter.getUnderSample(); // Only for tick mark...
     #ifdef __MWERKS__
     yield();
@@ -145,21 +138,23 @@
      if (nn%(200*80) == 0) cout << endl;
     // Si rien de dispo parmi les triggering, alors on passe au suivant
-    bool hasValue = false;
-    for (int i=0; i<toiflags.size(); i++) {
-       if (!iter.isTrig(i)) continue;
-       if (iter.canGetValue(i)) {hasValue=true; break;}
-    }
-    if (!hasValue) continue;
+    // normalement, c'est gere par le toiiter...
+    //bool hasValue = false;
+    //for (int i=0; i<toiflags.size(); i++) {
+    //   if (!iter.isTrig(i)) continue;
+    //   if (iter.canGetValue(i)) {hasValue=true; break;}
+    //}
+    //if (!hasValue) continue;
     int icol=0;
-    for (int i=0; i<toiflags.size(); i++) {
+    for (int i=0; i<tois.size(); i++) {
       double value = iter.getValue(i);
       bool   ok    = iter.canGetValue(i);
-      bool   isnew = iter.newValue(i);
-      flg    flag  = toiflags[i];
-      if (flag & hasflag) {
-        (this->*outValue)(icol,  (ok && isnew ? 1 : 0));
-        icol++;
-      }
-      if (((flag & useNA)!=0 && !isnew) || !ok) 
+     // bool   isnew = iter.newValue(i);
+     // flg    flag  = toiflags[i];
+     // if (flag & hasflag) {
+     //   (this->*outValue)(icol,  (ok && isnew ? 1 : 0));
+     //   icol++;
+     // }
+     //if (((flag & useNA)!=0 && !isnew) || !ok) 
+      if (!ok) 
         (this->*outValue)(icol,  0, true);
       else
@@ -184,5 +179,5 @@
   for (list<string>::iterator i = headeropt.begin(); i != headeropt.end(); i++)
     *ostr << (*i) << '\n';;
-  block_type_param* blk = iter.lastParam();
+  block_type_param* blk = iter.getFSet().lastParam();
   if (blk) {
     int nb = blk->param.n_max_bolo;
@@ -227,4 +222,29 @@
 }
 
+list<string> ArchTOI::buildNames() {
+  list<string> toinames;
+  map<string,int> namecount;
+  
+  for (list<TOI>::iterator i = tois.begin(); i != tois.end(); i++) {
+    namecount[(*i).name]++;
+  }
+  
+  map<string,int> curcount;
+  for (list<TOI>::iterator i = tois.begin(); i != tois.end(); i++) {
+    string toiname = (*i).name;
+    if (namecount[(*i).name]>1) {
+      char s[10];
+      sprintf(s,"_%d",curcount[(*i).name]++);
+      toiname += s;
+    }
+    if ((*i).index != TOI::unspec) {
+      char s[10];
+      sprintf(s,"_%d",(*i).index);
+      toiname += s;
+    }
+    toinames.push_back(toiname);
+  }
+  return toinames;
+}
 
 void ArchTOI::openFile_F(string const& filename) {
@@ -237,5 +257,8 @@
 }
 
+
 void ArchTOI::outHeader_F(TOIIter& iter) {  
+  list<string> toinames = buildNames();
+
   int ncols=toinames.size();
   
@@ -244,8 +267,10 @@
   char** colunits = new (char*[ncols]);
   int j=0;
-  for (list<string>::iterator i = toinames.begin(); i != toinames.end(); i++,j++) {
+  list<TOI>::iterator kk = tois.begin();
+  for (list<string>::iterator i = toinames.begin(); i != toinames.end(); i++,j++,kk++) {
     colnames[j] = const_cast<char*>((*i).c_str()); // should work for most STL implementations... Check...
     coltypes[j] = "1D";
-    colunits[j] = " ";
+    colunits[j] = const_cast<char*>((*kk).unit.c_str());
+    cout << (*i).c_str() << " " << ((*kk).unit.c_str()) << endl;
   }
   
@@ -261,9 +286,11 @@
   int ntoireq = headertoi.size();
   fits_write_key(fptr, TINT, "TOIREQ", &ntoireq, NULL, &fitsStatus);
-  for (list<string>::iterator i = headertoi.begin(); i != headertoi.end(); i++,j++) {
+  list<string>::iterator kkk = toinames.begin();
+  for (list<string>::iterator i = headertoi.begin(); i != headertoi.end(); i++,j++,kkk++) {
     char line[80];
     strcpy(line, (*i).c_str());
     char* pline = line;
-    fits_write_keys_str(fptr, "TOIREQ", j, 1, &pline, (char**) NULL, &fitsStatus);
+    char* cmt   = const_cast<char*>((*kkk).c_str());
+    fits_write_keys_str(fptr, "TOIREQ", j, 1, &pline, &cmt, &fitsStatus);
   }
   j=1;
@@ -278,5 +305,5 @@
 
   // Noms des bolos
-  block_type_param* blk = iter.lastParam();
+  block_type_param* blk = iter.getFSet().lastParam();
   if (blk) {
     int nb = blk->param.n_max_bolo;
@@ -338,2 +365,4 @@
   fits_report_error(stderr, fitsStatus);  /* print out any error messages */
 }
+
+
Index: trunk/Poubelle/archTOI.old/archtoi.h
===================================================================
--- trunk/Poubelle/archTOI.old/archtoi.h	(revision 533)
+++ trunk/Poubelle/archTOI.old/archtoi.h	(revision 534)
@@ -9,5 +9,5 @@
 #include <list>
 #include <vector>
-#include "toisvr.h"
+#include "toiiter.h"
 #include "fitsio.h"
 
@@ -25,15 +25,13 @@
             useNA   = 2};
             
-  virtual bool processTOIReq(string line, string toiname, TOIKind toi, int index, 
-                             bool interp, bool repet, bool flag, bool notrig);
+  virtual bool processTOIReq(TOI const& toi, string line);
   virtual bool processOption(string keyw, string args);
   
 protected:
   void init();
-  TOISvr svr;
+  TOIIter iter;
   list<string> headertoi;
   list<string> headeropt;
-  list<string> toinames;
-  vector<flg>  toiflags;
+  list<TOI> tois;
   fmt format;
   string undef;
@@ -46,4 +44,6 @@
   void (ArchTOI::*endLine)();
   void (ArchTOI::*closeFile)();
+  
+  list<string> buildNames();
   
   void openFile_A(string const& filename);
Index: trunk/Poubelle/archTOI.old/archtoimain.cc
===================================================================
--- trunk/Poubelle/archTOI.old/archtoimain.cc	(revision 533)
+++ trunk/Poubelle/archTOI.old/archtoimain.cc	(revision 534)
@@ -7,6 +7,7 @@
 
 #include "archeopsfile.h"
+
 #include "archtoi.h"
-#include "toisvr.h"
+#include "toimanager.h"
 
 //#include <profiler.h>
@@ -23,6 +24,9 @@
     argc = ccommand(&argv);
 #endif
+
+
     if (argc != 3) {
       cerr << "usage: archtoi reqfile datafile" << endl;
+      cerr << "or:    archtoi -h reqfile" << endl;
       return(-1);
     }
@@ -30,9 +34,21 @@
 //   ProfilerInit(collectDetailed, bestTimeBase, 10000, 200);
 
+    if (argv[1] == string("-h")) {
+      ArchTOI toi(argv[2]);
+      TOIManager::dumpAvailTOIs(cout);
+      exit(0);
+    }
+
     
-    ArchTOI toi(argv[1]);
-    toi.run(argv[2]);
+    try {
+      ArchTOI toi(argv[1]);
+      toi.run(argv[2]);
+    } catch (ArchExc exc) {
+      cerr << exc.Msg() << endl; 
+      exit(-1);
+    }
     
 //    ProfilerDump("\pprofiler.data");
     return(0);
 }
+
Index: trunk/Poubelle/archTOI.old/archvers.h
===================================================================
--- trunk/Poubelle/archTOI.old/archvers.h	(revision 533)
+++ trunk/Poubelle/archTOI.old/archvers.h	(revision 534)
@@ -2,6 +2,6 @@
 #define ARCHVERS_H
 
-#define ARCHTOI_VERS "1.3"
-#define ARCHTOI_TAG  "V_241099"
+#define ARCHTOI_VERS "2.0"
+#define ARCHTOI_TAG  "V_011199"
 
 #endif
Index: trunk/Poubelle/archTOI.old/ark.h
===================================================================
--- trunk/Poubelle/archTOI.old/ark.h	(revision 534)
+++ trunk/Poubelle/archTOI.old/ark.h	(revision 534)
@@ -0,0 +1,8 @@
+#ifndef nb_max_bolo
+#define _archeops		//  Acquisition Archeops (avec transputer) 
+#define programme
+extern "C" {
+#include "archeops.h"
+#include "arcunit.h"
+}
+#endif
Index: trunk/Poubelle/archTOI.old/auxgps.h
===================================================================
--- trunk/Poubelle/archTOI.old/auxgps.h	(revision 533)
+++ trunk/Poubelle/archTOI.old/auxgps.h	(revision 534)
@@ -10,4 +10,7 @@
 
   virtual int getLocation(double mjd, double& lat, double& lon, double& alt)=0;
+  virtual bool canGetLocation(double mjd)=0;
+  virtual double getStartMJD()=0;
+  virtual double getEndMJD()=0;
   virtual AuxGPS* clone()=0;
 
Index: trunk/Poubelle/archTOI.old/auxinterpgps.cc
===================================================================
--- trunk/Poubelle/archTOI.old/auxinterpgps.cc	(revision 533)
+++ trunk/Poubelle/archTOI.old/auxinterpgps.cc	(revision 534)
@@ -18,4 +18,16 @@
   ilast = elems.upper_bound(elem(mjd,0,0,0));
   ilastok = (ilast != elems.end() && ilast != elems.begin());
+}
+
+bool AuxInterpGPS::canGetLocation(double mjd) {
+  return (mjd > (*elems.begin()).mjd && mjd < (*--elems.end()).mjd);
+}
+
+double AuxInterpGPS::getStartMJD() {
+  return (*elems.begin()).mjd;
+}
+
+double AuxInterpGPS::getEndMJD() {
+  return (*--elems.end()).mjd;
 }
 
Index: trunk/Poubelle/archTOI.old/auxinterpgps.h
===================================================================
--- trunk/Poubelle/archTOI.old/auxinterpgps.h	(revision 533)
+++ trunk/Poubelle/archTOI.old/auxinterpgps.h	(revision 534)
@@ -15,4 +15,7 @@
   AuxInterpGPS();
   virtual int getLocation(double mjd, double& lat, double& lon, double& alt);
+  virtual bool canGetLocation(double mjd);
+  virtual double getStartMJD();
+  virtual double getEndMJD();
   
   void FitsDump(string const& filename);
Index: trunk/Poubelle/archTOI.old/cmvplgalc.cc
===================================================================
--- trunk/Poubelle/archTOI.old/cmvplgalc.cc	(revision 534)
+++ trunk/Poubelle/archTOI.old/cmvplgalc.cc	(revision 534)
@@ -0,0 +1,43 @@
+#include <iostream.h>
+#include <stdlib.h>
+#include <stdio.h>
+#include <string.h>
+#include <math.h>
+
+#include "plgalcross.h"
+
+#define PSCAL2(_v1_,_v2_) (_v1_[0]*_v2_[0]+_v1_[1]*_v2_[1]+_v1_[2]*_v2_[2])
+#define TOCART(_a_,_d_,_v_) \
+        {_v_[0]=cos(_d_)*cos(_a_); _v_[1]=cos(_d_)*sin(_a_); _v_[2]=sin(_d_);}
+
+////////////////////////////////////////////////////////////////////////////////////////
+int main(int narg,char *arg[])
+{
+{
+// test FindPerpEquat
+/*
+cmvplgalc >! toto
+cat toto | awk -v f=1e-10 '{if($1==0&&($9>f||$9<-f||$10>f||$10<-f)) print $0}'
+*/
+double ap,dp,v1[3],v2[3],vp[3],a1,d1,a2,d2;
+int rc;
+for(int aa1=0;aa1<=24;aa1+=1) for(int dd1=-90;dd1<=90;dd1+=15)
+for(int aa2=0;aa2<=24;aa2+=1) for(int dd2=-90;dd2<=90;dd2+=15) {
+  a1 = (double) aa1; d1 = (double) dd1;
+  a2 = (double) aa2; d2 = (double) dd2;
+  rc = FindPerpEquat(a1,d1,a2,d2,ap,dp);
+  printf("%d   %g %g   %g %g   %g %g",rc,a1,d1,a2,d2,ap,dp);
+  a1 /=  HRS_IN_RADIAN; d1 /=  DEG_IN_RADIAN;
+  a2 /=  HRS_IN_RADIAN; d2 /=  DEG_IN_RADIAN;
+  ap /=  HRS_IN_RADIAN; dp /=  DEG_IN_RADIAN;
+  TOCART(a1,d1,v1)
+  TOCART(a2,d2,v2)
+  TOCART(ap,dp,vp)
+  printf("   %g   %g %g\n"
+        ,PSCAL2(vp,vp),PSCAL2(v1,vp),PSCAL2(v2,vp));
+}
+}
+
+exit(0);
+}
+
Index: trunk/Poubelle/archTOI.old/dyffttools.cc
===================================================================
--- trunk/Poubelle/archTOI.old/dyffttools.cc	(revision 533)
+++ trunk/Poubelle/archTOI.old/dyffttools.cc	(revision 534)
@@ -1,4 +1,5 @@
 #include "dyffttools.h"
 
+// D. Yvon, CE Saclay, DAPNIA/SPP, 08/99
 
 //	Librairie FFTMayer enrobée pour etre utilisable facilement en C++
Index: trunk/Poubelle/archTOI.old/dyffttools.h
===================================================================
--- trunk/Poubelle/archTOI.old/dyffttools.h	(revision 533)
+++ trunk/Poubelle/archTOI.old/dyffttools.h	(revision 534)
@@ -1,4 +1,7 @@
 #ifndef DYFFTTOOLS_SEEN
-#define DYFFTTOOLS
+#define DYFFTTOOLS_SEEN
+
+// D. Yvon, CE Saclay, DAPNIA/SPP, 08/99
+
 double DYWindow(double index, double indexMax);
 
Index: trunk/Poubelle/archTOI.old/formepulse.cc
===================================================================
--- trunk/Poubelle/archTOI.old/formepulse.cc	(revision 533)
+++ trunk/Poubelle/archTOI.old/formepulse.cc	(revision 534)
@@ -2,4 +2,5 @@
 #include <fstream.h>
 
+// D. Yvon, CE Saclay, DAPNIA/SPP, 08/99
 
 #include <math.h>
@@ -13,7 +14,6 @@
 #include "ssthardware.h"
 
-
 #define LTab (2048)
-#define LSave (128)
+#define LSave (256)
 #define Tpas (5.e-4)
 //float PulseOptOrigin=LTab/16.*Tpas;
@@ -22,5 +22,12 @@
 //#define DYTestRun
 
-
+/*
+FormePulse::FormePulse() {
+ 	gainElec=0.;
+	FullwidthHalfMax=0;
+	ShapeArr=new double[LSave];
+	for(int i=0; i<LSave; i++)  ShapeArr[i]=0.;
+}
+*/
 
 FormePulse::FormePulse(TransFuncElec TF) {
@@ -129,5 +136,5 @@
 	for(int i=0; i<LSave; i++)  ShapeArr[i]=PulseInReel[i]/Max;
 
-#ifdef DYTestRun	
+//#ifdef DYTestRun	
 		//On ecrit le resultat dans un fichier 
 		char s2[32]="Resultatfiltrage.txt";
@@ -139,6 +146,7 @@
 
 		dlout<<"Impulsion courant de: "<<SSTFPulseCourant<<" Ampères"<<endl;
-		dlout<<"Maximum d'amplitude: "<<max<< " Volts"<<endl;
-		dlout<<" gain chaine preampli: "<<gainElec<<endl<<endl;
+		dlout<<"Maximum d'amplitude: "<<Max<< " Volts"<<endl;
+		dlout<<" gain chaine preampli: "<<gainElec<<endl;
+		dlout<<"largueur a mi hauteur: "<<FullwidthHalfMax<<endl<<endl;
 		dlout<<"Temps"<<"\tPartie Reelle"<<endl;
 
@@ -146,5 +154,5 @@
 			dlout<<k*Tpas<<"\t"<<ShapeArr[k]<<endl;
 		}	
-#endif
+//#endif
 
 
@@ -163,5 +171,5 @@
 	return *this;
 }
-	
+
 FormePulse::~FormePulse() {
 	delete[] ShapeArr;
@@ -174,8 +182,8 @@
 
 double FormePulse::PulseShape(double temps) {
+	double returnValue;
 	int ientier=(int)(temps/Tpas);
-	double returnValue;
 	if (ientier<0) returnValue=0.;
-	else if (ientier>=LSave) returnValue= ShapeArr[127];
+	else if (ientier>=LSave) returnValue= ShapeArr[LSave-1];
 	else {
 		double Min=ShapeArr[ientier];
@@ -193,4 +201,5 @@
 	//en secondes
 	return returnVal;
+//	return returnVal=30.e-3;			//Gros BUGG!!!!!
 }
 	
Index: trunk/Poubelle/archTOI.old/formepulse.h
===================================================================
--- trunk/Poubelle/archTOI.old/formepulse.h	(revision 533)
+++ trunk/Poubelle/archTOI.old/formepulse.h	(revision 534)
@@ -2,4 +2,5 @@
 #define FORMEPULSE_SEEN
 
+// D. Yvon, CE Saclay, DAPNIA/SPP, 08/99
 
 #define  SSTFPulseCourant 1.E-9 	
@@ -11,5 +12,6 @@
 class FormePulse {
 public:
-	FormePulse(TransFuncElec);
+	FormePulse(TransFuncElec TF);
+	FormePulse();						// Cas zero lecture
 	FormePulse& operator =(const FormePulse&);
 	~FormePulse();
Index: trunk/Poubelle/archTOI.old/galcrosslocator.cc
===================================================================
--- trunk/Poubelle/archTOI.old/galcrosslocator.cc	(revision 534)
+++ trunk/Poubelle/archTOI.old/galcrosslocator.cc	(revision 534)
@@ -0,0 +1,114 @@
+// galcrosslocator.cc
+// Eric Aubourg         CEA/DAPNIA/SPP   octobre 1999
+
+#include "galcrosslocator.h"
+#include "archexc.h"
+#include "archparam.h"
+#include "templocator.h"
+
+#define alphaZenith     "alphaZenith"
+#define deltaZenith     "deltaZenith"
+#define rotSpeed        "rotSpeed"
+#define rotSpeedSample1 "rotSpeedSample1"
+#define rotSpeedSample2 "rotSpeedSample2"
+#define lastCrossSample "lastCrossSample"
+#define nextCrossSample "nextCrossSample"
+#define azimuthFPC      "azimuthFPC"
+#define elvFPC          "elvFPC"
+#define alphaFPC        "alphaFPC"
+#define deltaFPC        "deltaFPC"
+#define azimuthBolo     "azimuthBolo"
+#define elvBolo         "elvBolo"
+#define alphaBolo       "alphaBolo"
+#define deltaBolo       "deltaBolo"
+
+
+GalCrossLocator::GalCrossLocator() {
+  possibleTOIs.insert(TOI(alphaZenith,      TOI::unspec, "", "hours",   "galcross0"));  
+  possibleTOIs.insert(TOI(deltaZenith,      TOI::unspec, "", "degrees", "galcross0"));  
+  possibleTOIs.insert(TOI(rotSpeed,         TOI::unspec, "", "deg/s",   "galcross0"));  
+  possibleTOIs.insert(TOI(rotSpeedSample1,  TOI::unspec, "", "integer", "galcross0"));  
+  possibleTOIs.insert(TOI(rotSpeedSample2,  TOI::unspec, "", "integer", "galcross0"));  
+  possibleTOIs.insert(TOI(lastCrossSample,  TOI::unspec, "", "integer", "galcross0"));  
+  possibleTOIs.insert(TOI(lastCrossSample,  TOI::unspec, "", "integer", "galcross0"));  
+  possibleTOIs.insert(TOI(nextCrossSample,  TOI::unspec, "", "integer", "galcross0"));  
+  possibleTOIs.insert(TOI(azimuthFPC,       TOI::unspec, "", "degrees", "galcross0"));  
+  possibleTOIs.insert(TOI(elvFPC,           TOI::unspec, "", "degrees", "galcross0"));  
+  possibleTOIs.insert(TOI(alphaFPC,         TOI::unspec, "", "hours",   "galcross0"));  
+  possibleTOIs.insert(TOI(deltaFPC,         TOI::unspec, "", "degrees", "galcross0"));  
+  possibleTOIs.insert(TOI(azimuthBolo,      TOI::all,    "", "degrees", "galcross0"));  
+  possibleTOIs.insert(TOI(elvBolo,          TOI::all,    "", "degrees", "galcross0"));  
+  possibleTOIs.insert(TOI(alphaBolo,        TOI::all,    "", "hours",   "galcross0"));  
+  possibleTOIs.insert(TOI(deltaBolo,        TOI::all,    "", "degrees", "galcross0"));  
+}
+
+string GalCrossLocator::getName() {
+  return("GalCrossLocator 1.0");
+}
+
+bool GalCrossLocator::canGetValue(long sampleNum, TOI const&) {
+  int dum;
+  return (tempLocator.getCrossSamples(sampleNum, dum, dum) == 0);
+}
+
+
+double GalCrossLocator::getValue(long sampleNum, TOI const& toi) {
+  if (!canGetValue(sampleNum, toi)) return -1;
+
+  map<TOI, TOIProducer*> m = neededTOIs[toi];
+  double lat, lon, ts;
+  
+  for (map<TOI, TOIProducer*>::iterator i = m.begin(); i != m.end(); i++) {
+    TOI inToi = (*i).first;
+    TOIProducer* prod =  (*i).second;
+    if (inToi.name == "latitude")  lat = prod->getValue(sampleNum, inToi);
+    if (inToi.name == "longitude") lon = prod->getValue(sampleNum, inToi);
+    if (inToi.name == "tsid")       ts = prod->getValue(sampleNum, inToi);
+  }
+    
+  tempLocator.setEarthPos(lon,lat);
+  tempLocator.setTSid(ts);
+
+  if (toi.name == alphaZenith)     return tempLocator.getAlphaZenith();
+  if (toi.name == deltaZenith)     return tempLocator.getDeltaZenith();
+  if (toi.name == rotSpeed)        return tempLocator.getRotSpeed(sampleNum);
+
+  if (toi.name == azimuthFPC)      return tempLocator.getAzimutCenter(sampleNum);
+  if (toi.name == elvFPC)          return tempLocator.getElvCenter(sampleNum);
+  if (toi.name == alphaFPC)        return tempLocator.getAlphaCenter(sampleNum);
+  if (toi.name == deltaFPC)        return tempLocator.getDeltaCenter(sampleNum);
+  
+  if (toi.name == azimuthBolo)     return tempLocator.getAzimutBolo(sampleNum, toi.index);
+  if (toi.name == elvBolo)         return tempLocator.getElvBolo(sampleNum, toi.index);
+  if (toi.name == alphaBolo)       return tempLocator.getAlphaBolo(sampleNum, toi.index);
+  if (toi.name == deltaBolo)       return tempLocator.getDeltaBolo(sampleNum, toi.index);
+
+  if (toi.name == lastCrossSample || toi.name == rotSpeedSample1) {
+     int SN1, SN2;
+     tempLocator.getCrossSamples(sampleNum, SN1, SN2);
+     return SN1;
+  } 
+  if (toi.name == nextCrossSample || toi.name == rotSpeedSample2) {
+     int SN1, SN2;
+     tempLocator.getCrossSamples(sampleNum, SN1, SN2);
+     return SN2;
+  } 
+  
+  return -1;
+}
+
+
+set<TOI> GalCrossLocator::reqTOIFor(TOI const&) {
+  set<TOI> t; 
+  t.insert(TOI("latitude",  TOI::unspec, "interp"));
+  t.insert(TOI("longitude", TOI::unspec, "interp"));
+  t.insert(TOI("tsid",      TOI::unspec));
+  return t;
+}
+
+
+
+
+
+
+
Index: trunk/Poubelle/archTOI.old/galcrosslocator.h
===================================================================
--- trunk/Poubelle/archTOI.old/galcrosslocator.h	(revision 534)
+++ trunk/Poubelle/archTOI.old/galcrosslocator.h	(revision 534)
@@ -0,0 +1,21 @@
+// galcrosslocator.h
+// Eric Aubourg         CEA/DAPNIA/SPP   octobre 1999
+
+#ifndef GALCROSSLOCATOR_H
+#define GALCROSSLOCATOR_H
+
+#include "toipullproducer.h"
+
+class GalCrossLocator : public TOIPullProducer {
+public:
+  GalCrossLocator();
+  virtual string getName();
+  virtual double getValue(long sampleNum, TOI const& toi);
+  virtual bool   canGetValue(long sampleNum, TOI const& toi);
+
+protected:
+  virtual set<TOI>     reqTOIFor(TOI const&);
+};
+
+
+#endif
Index: trunk/Poubelle/archTOI.old/gyrocalibrator.cc
===================================================================
--- trunk/Poubelle/archTOI.old/gyrocalibrator.cc	(revision 534)
+++ trunk/Poubelle/archTOI.old/gyrocalibrator.cc	(revision 534)
@@ -0,0 +1,48 @@
+// gyrocalibrator.cc
+// Eric Aubourg         CEA/DAPNIA/SPP   octobre 1999
+
+// assumption : same calibration for all gyros...
+
+
+#include "gyrocalibrator.h"
+
+#define gyroCal    "gyroCal"
+#define gyroSpeed  "gyroSpeed"
+
+GyroCalibrator::GyroCalibrator() {
+  possibleTOIs.insert(TOI(gyroCal,      TOI::unspec, "linearCal", "deg/s/V"));  
+  possibleTOIs.insert(TOI(gyroSpeed,    TOI::all   , "linearCal", "deg/s"));  
+  
+  //needAfter = 3600;  // about one turn...
+  startSample = -1;
+  lastFence1 = lastFence2 = -1;
+}
+
+string GyroCalibrator::getName() {
+  return("GyroCalibrator 1.0");
+}
+
+
+set<TOI> GyroCalibrator::reqTOIFor(TOI const&) {
+  set<TOI> t; 
+  t.insert(TOI("rotSpeed",        TOI::unspec)); // pull only
+  t.insert(TOI("rotSpeedSample1", TOI::unspec)); // pull only
+  t.insert(TOI("rotSpeedSample2", TOI::unspec)); // pull only
+  t.insert(TOI("gyroV", 0));  // push
+  t.insert(TOI("gyroV", 1));  // push
+  t.insert(TOI("gyroV", 2));  // push
+  return t;
+}
+
+void GyroCalibrator::dataFeed(TOIProducer* source, TOI const& toi, long sampleNum, double value) {
+  if (toi.name != "gyroV" || toi.index != 2) return;
+  
+  if (gyro2.empty()) {
+    startSample = sampleNum;
+  }
+  
+  gyro2.push_back(value);
+}
+
+
+
Index: trunk/Poubelle/archTOI.old/gyrocalibrator.h
===================================================================
--- trunk/Poubelle/archTOI.old/gyrocalibrator.h	(revision 534)
+++ trunk/Poubelle/archTOI.old/gyrocalibrator.h	(revision 534)
@@ -0,0 +1,32 @@
+// gyrocalibrator.h
+// Eric Aubourg         CEA/DAPNIA/SPP   octobre 1999
+
+#ifndef GYROCALIBRATOR_H
+#define GYROCALIBRATOR_H
+
+#include "toiderivproducer.h"
+
+#include <vector>
+
+class GyroCalibrator : public TOIDerivProducer {
+public:
+  GyroCalibrator();
+  virtual void dataFeed(TOIProducer* source, TOI const& toi, long sampleNum, double value);
+  virtual string getName();
+
+  virtual bool   canGetValue(long sampleNum, TOI const& toi); // for this samplenum
+  virtual double getValue(long sampleNum, TOI const& toi);
+
+protected:
+  virtual set<TOI>     reqTOIFor(TOI const&);
+  virtual void         propagateLowBound(TOI const&, long sampleNum);
+  
+private:
+  long startSample;
+  vector<double> gyro2; 
+  long lastFence1, lastFence2;
+};
+
+
+
+#endif
Index: trunk/Poubelle/archTOI.old/gyrofftana.cc
===================================================================
--- trunk/Poubelle/archTOI.old/gyrofftana.cc	(revision 534)
+++ trunk/Poubelle/archTOI.old/gyrofftana.cc	(revision 534)
@@ -0,0 +1,90 @@
+#include <iostream.h>
+#include <fstream.h>
+#include <iomanip.h>
+
+#include "archeopsfile.h"
+#include "archtoi.h"
+#include "toisvr.h"
+
+
+#ifdef __MWERKS__
+#include <console.h>
+#endif
+
+using namespace std;  //introduces namespace std
+
+#ifdef __MWERKS__
+#include "Events.h"
+#include "LowMem.h"
+#include "sioux.h"
+static int macSleepTicks = 0;
+static int macRunTicks = 10;
+static void yield()
+{
+    EventRecord theEvent;
+    static long int macLastTicks;
+    long int ticks = LMGetTicks();
+    if (ticks - macLastTicks >= macRunTicks) {
+      if (WaitNextEvent(everyEvent, &theEvent,macSleepTicks,0))
+        SIOUXHandleOneEvent(&theEvent);
+      macLastTicks = LMGetTicks();
+    }
+}
+#endif
+
+int main(int argc, char** argv)
+{	
+
+  TOISvr svr;
+  svr.AddInfo(mjd);
+  svr.AddInfo(gyroRaw,0);
+  svr.AddInfo(gyroRaw,1);
+  svr.AddInfo(gyroRaw,2);
+  
+  svr.SetDirectory("Sans titre");
+  svr.OnBoardRecorderFiles(true);
+  svr.SetTimeInterval(1377.88, 1377.95);
+  
+  // Pour le moment, on sort, en binaire, les points moyennes sur 100
+  
+  ofstream s("gyro.data",ios::binary);
+  ofstream s1("gyro1.data",ios::binary);
+  cout << "starting" << endl;
+  TOIIter iter = svr.DoQuery();
+  const int n=72;
+  int i=0;
+  int ndata=0;
+  double xmjd, gyr0, gyr1, gyr2;
+  double gyr00, gyr01, gyr02;
+  while (iter.Next()) {
+    if (i==0) {
+      xmjd = iter.getValue(0);
+      gyr0=gyr1=gyr2=0;
+      gyr00 = iter.getValue(1);
+      gyr01 = iter.getValue(2);
+      gyr02 = iter.getValue(3);
+    }
+    gyr0 += iter.getValue(1);
+    gyr1 += iter.getValue(2);
+    gyr2 += iter.getValue(3);
+    i++;
+    if (i >= n) {
+      gyr0 /= n;
+      gyr1 /= n;
+      gyr2 /= n;
+      s.write((char*) &xmjd, sizeof(xmjd));
+      s.write((char*) &gyr0, sizeof(gyr0));
+      s.write((char*) &gyr1, sizeof(gyr1));
+      s.write((char*) &gyr2, sizeof(gyr2));
+      s1.write((char*) &xmjd, sizeof(xmjd));
+      s1.write((char*) &gyr00, sizeof(gyr00));
+      s1.write((char*) &gyr01, sizeof(gyr01));
+      s1.write((char*) &gyr02, sizeof(gyr02));
+      ndata++;
+      yield();
+      i=0;
+    }
+  }
+  cout << "Done. " << ndata << " samples written." << endl;
+
+}
